// Header file for loupeznik.c

#define EEPROM_SECTION  __attribute__ ((section (".eeprom")))

// bitove flagy stavu USARTu
#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<PE)
#define DATA_OVERRUN (1<<DOR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC) 

// velikost UART bufferu
#define RX_BUFFER_SIZE 6

// stavova ledka
#define LED 0x02
#define LED_SLOW TCCR0=0x05  // nastaveni TCCR0 na delicku 1024 pro pomale blikani led
#define LED_FAST TCCR0=0x04  // nastaveni TCCR0 na delicku 256 pro rychle blikani led


// pocet rele v systemu
#define RELAYS_COUNT 10

// vystupy na rele                 
#define RELE_01_ON PORTC |= 0x20     //PC5
#define RELE_01_OFF PORTC &= ~0x20
#define RELE_02_ON PORTC |= 0x10     //PC4
#define RELE_02_OFF PORTC &= ~0x10
#define RELE_03_ON PORTC |= 0x08     //PC3
#define RELE_03_OFF PORTC &= ~0x08
#define RELE_04_ON PORTC |= 0x04     //PC2
#define RELE_04_OFF PORTC &= ~0x04
#define RELE_05_ON PORTC |= 0x02     //PC1
#define RELE_05_OFF PORTC &= ~0x02
#define RELE_06_ON PORTC |= 0x01     //PC0
#define RELE_06_OFF PORTC &= ~0x01
#define RELE_07_ON PORTD |= 0x20     //PD5
#define RELE_07_OFF PORTD &= ~0x20
#define RELE_08_ON PORTD |= 0x40     //PD6
#define RELE_08_OFF PORTD &= ~0x40
#define RELE_09_ON PORTD |= 0x80     //PD7
#define RELE_09_OFF PORTD &= ~0x80
#define RELE_10_ON PORTB |= 0x01     //PB0
#define RELE_10_OFF PORTB &= ~0x01

// makro na smazani watchodogu 
#define CLRWDT  asm("wdr")


// prototypy funkci
void delay(unsigned int cas);
unsigned char is_numeric(unsigned char arg);
unsigned int decpower(unsigned char exp);
unsigned char rxb2char(unsigned char *value, unsigned char start, unsigned char count);
void test_relcon(void);
void putchar1(char c);
void write(char *sss);
void writestr(char *sss);
void print_char(unsigned char arg, unsigned char rad);
unsigned char cmdtest(unsigned char cmd, unsigned char count);
void rs232_showrelcon(void);
void rs232_allocrelcon(void);
void rs232_reset(void);
void rs232_command(void);   
void relay_on(unsigned char rele);  
void relay_off(void);


